<?
// MegaLettering translated comics PHP engine Copyright (c) 2003 Lapo Luchini <lapo@lapo.it>
// $Header: /cvs/MTi/editor.php,v 1.52 2003/10/22 23:03:29 lapo Exp $

// This file is part of MegaLettering.
//
// MegaLettering is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// MegaLettering is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with MegaLettering; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// This page shouldn't be cached at all <http://it.php.net/manual/en/function.header.php>
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once("db.php");
require_once("image.php");

$lang = 'it';
if(isset($_SERVER['HTTP_HOST']))
    $lang = substr($_SERVER['HTTP_HOST'], -2);
if(isset($_GET["lang"]))
    $lang = substr($_GET["lang"], 0, 2);
$id = 0;
if(isset($_GET['id']) && is_numeric($_GET['id']))
    $id = (int)$_GET['id'];
$fum = 0;
if(isset($_GET['fum']) && is_numeric($_GET['fum']))
    $fum = (int)$_GET['fum'];
$debug = 0;
if(isset($_GET['debug']) && is_numeric($_GET['debug']))
    $debug = (int)$_GET['debug'];
if($debug)
    $debug = '&amp;debug=1';
else
    $debug = '';

// controlla la lingua
require_once('gettext.php');

if(isset($_POST['tipo'])) { // è un inserimento in DB
    if(($lang == 'en'))
	die(_('English strips are not updatable.'));
    elseif($_POST['tipo'] == 'titolo') {
	$data = mysql_real_escape_string($_POST['pubblicazione']);
	$q = @mysql_query("SELECT IDStrip FROM ${dbprefix}_Titles WHERE IDLanguage = '$lang' AND IDStrip = $_POST[idtavola] AND Pubblicazione = '$data'")
	    or die(_('I can\'t query the DB: ') . mysql_error());
	if($row = @mysql_fetch_row($q)) {
	    // ID e data sono uguali, aggiorno Titolo e Discussione
	    @mysql_query("UPDATE ${dbprefix}_Titles SET Testo = '" . mysql_real_escape_string($_POST['testo']) . '\', ' .
		'Discussione = \'' . mysql_real_escape_string($_POST['discussione']) . '\' ' .
		"WHERE IDLanguage = '$lang' AND IDStrip = $_POST[idtavola]")
		or die(_('I can\'t update the DB: ') . mysql_error());
	} else {
	    $date_ok = TRUE;
	    if($_POST['pubblicazione_ok'] != '1') {
		@mysql_free_result($q);
		$q = @mysql_query("SELECT IDStrip FROM ${dbprefix}_Titles WHERE IDLanguage = '$lang' AND IDStrip <> $_POST[idtavola] AND Pubblicazione >= '$data'")
		    or die(_('I can\'t query the DB: ') . mysql_error());
		if($row = @mysql_fetch_row($q))
		    $date_ok = FALSE;
	    }
	    if($date_ok) {
		@mysql_free_result($q);
		$q = @mysql_query("SELECT IDStrip FROM ${dbprefix}_Titles WHERE IDLanguage = '$lang' AND IDStrip = $_POST[idtavola]")
		    or die(_('I can\'t query the DB: ') . mysql_error());
		if($row = @mysql_fetch_row($q))
		    @mysql_query("UPDATE ${dbprefix}_Titles SET " .
			"Testo = '" . mysql_real_escape_string($_POST['testo']) . "', " .
			"Pubblicazione = '$data', " .
			"Discussione = '" . mysql_real_escape_string($_POST['discussione']) . "' " .
			"WHERE IDLanguage = '$lang' AND IDStrip = $_POST[idtavola]")
			or die(_('I can\'t update the DB: ') . mysql_error());
		else
		    @mysql_query("INSERT ${dbprefix}_Titles (IDLanguage, IDStrip, Testo, Pubblicazione, Discussione) VALUES (" .
			"'$lang', " .
			(int)$_POST['idtavola'] . ', ' .
			"'" . mysql_real_escape_string($_POST['testo']) . "', " .
			"'$data', " .
			"'" . mysql_real_escape_string($_POST['discussione']) . "')")
			or die(_('I can\'t insert in the DB: ') . mysql_error());
	    } else
		printf(_('The date you inserted is previous to the date of a different existing strip (e.g. strip %1$d).'), $row[0]);
	}
	@mysql_free_result($q);
    } elseif($_POST['tipo'] == 'fumetto') {
	if(isset($_POST['insert']) && ($_POST['insert'] == 'Insert')) {
	    @mysql_query("INSERT ${dbprefix}_Baloons (IDStrip, Shape, IDCharacter) VALUES (" .
		$id . ', ' .
		"'" . mysql_real_escape_string($_POST['coords']) . "', " .
		(int)$_POST['idpersonaggio'] . ')')
		or die(_('I can\'t insert in the DB: ') . mysql_error());
	    $fum = mysql_insert_id();
	    @mysql_query("INSERT ${dbprefix}_Texts (IDLanguage, IDBaloon, CenterX, CenterY, Testo) VALUES (" .
		"'$lang', " .
		$fum . ', ' .
		(int)$_POST['centrox'] . ', ' .
		(int)$_POST['centroy'] . ', ' .
		"'" . mysql_real_escape_string($_POST['testo']) . "')")
		or die(_('I can\'t update the DB: ') . mysql_error());
	} elseif(isset($_POST['update']) && ($_POST['update'] == 'Update')) {
	    @mysql_query("REPLACE ${dbprefix}_Baloons (IDBaloon, IDStrip, Shape, IDCharacter) VALUES (" .
		(int)$_POST['idfumetto'] . ', ' .
		$id . ', ' .
		"'" . mysql_real_escape_string($_POST['coords']) . "', " .
		(int)$_POST['idpersonaggio'] . ')')
		or die(_('I can\'t update the DB: ') . mysql_error());
	    @mysql_query("REPLACE ${dbprefix}_Texts (IDText, IDLanguage, IDBaloon, CenterX, CenterY, Testo) VALUES (" .
		(int)$_POST['idtesto'] . ', ' .
		"'$lang', " .
		(int)$_POST['idfumetto'] . ', ' .
		(int)$_POST['centrox'] . ', ' .
		(int)$_POST['centroy'] . ', ' .
		"'" . mysql_real_escape_string($_POST['testo']) . "')")
		or die(_('I can\'t update the DB: ') . mysql_error());
	} elseif(isset($_POST['delete']) && $_POST['delete'] == 'Delete') {
	    @mysql_query("DELETE FROM ${dbprefix}_Baloons WHERE IDBaloon = " . (int)$_POST['idfumetto'])
		or die('Non riesco a cancellare dal DB: ' . mysql_error());
	    @mysql_query("DELETE FROM ${dbprefix}_Texts WHERE IDLanguage = '$lang' AND IDBaloon = " . (int)$_POST['idfumetto'])
		or die('Non riesco a cancellare dal DB: ' . mysql_error());
	    if($fum == $_POST['idfumetto'])
		$fum = 0;
	}
	@mysql_query("UPDATE ${dbprefix}_Titles SET Versione = NOW() WHERE IDLanguage = '$lang' AND IDStrip = $id")
	    or die(_('I can\'t update the DB: ') . mysql_error());
    } elseif($_POST['tipo'] == 'console') {
	@mysql_query("REPLACE ${dbprefix}_Console (IDConsole, IDLanguage, IDStrip, Posizione, Username, Immagine, ImmagineLink, ImmagineAlt, Titolo, Testo) VALUES (" .
	    (int)$_POST['idconsole'] . ', ' .
	    "'$lang', " .
	    $id . ', ' .
	    "'" . mysql_real_escape_string($_POST['posizione']) . "', " .
	    "'" . mysql_real_escape_string($_POST['username']) . "', " .
	    "'" . mysql_real_escape_string($_POST['immagine']) . "', " .
	    "'" . mysql_real_escape_string($_POST['imm_link']) . "', " .
	    "'" . mysql_real_escape_string($_POST['imm_alt']) . "', " .
	    "'" . mysql_real_escape_string($_POST['titolo']) . "', " .
	    "'" . mysql_real_escape_string($_POST['testo']) . "')")
	    or die(_('I can\'t update the DB: ') . mysql_error());
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
    <title>MegaLettering editor</title>

    <meta http-equiv="Content-Type" content="text/html; charset=UTF8" />
    <link rel="stylesheet" href="image/main.css" type="text/css"/>
    <link rel="shortcut icon" href="image/favicon.ico" type="image/x-icon"/>
</head>

<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#EB5252" vlink="#ECECA3">

<h1><b><tt>MegaLettering EDITOR</tt></b></h1>

<table>
    <tr>
	<td>Editor:</td>
	<td>[main]</td>
	<td><a href="editor_rantimg.php">[rant images]</a></td>
	<td><!--a href="editor_links.php?lang=<?=$lang?>"-->[links]<!--/a--></td>
    </tr>
</table>

<?
// Carico la strip (viene creata on-the-fly se non è up-to-date)
ob_start();
$strip = GetStrip($id, $lang);
$us = array_keys($style_cache, FALSE);
if(sizeof($us) > 0) {
    echo _('Unknown styles:');
    foreach($us as $s)
	echo " $s";
    echo "\n";
}
$errors = ob_get_contents();
ob_end_clean();
if($errors)
    echo "<pre>$errors</pre>";
?>
<map name="tav">
<?
$fum_for = 'p';
$fum_cx = '0';
$fum_cy = '0';
$fum_per = 0;
$q = @mysql_query("SELECT IDBaloon, IDStrip, Shape, IDCharacter FROM ${dbprefix}_Baloons WHERE IDStrip = $id") or die(_('I can\'t query the DB: ') . mysql_error());
while($row = @mysql_fetch_array($q))
    if($row['IDBaloon'] != $fum) {
	if($row['Shape']{0} == 'p')
	    echo '    <area shape="poly" coords="' . substr($row['Shape'], 2) . "\" href=\"?lang=$lang&amp;id=$id&amp;fum=" . $row['IDBaloon'] . "$debug\">\n";
    } else {
	$fum_for = (string)$row['Shape'];
	$fum_per = (int)$row['IDCharacter'];
    }
@mysql_free_result($q);
?>
</map>
<img name="myimage" src="<?=$strip['filename']?>" border="0" usemap="#tav" align="left">

<table>
    <tr><td colspan="2"><b><?=_('Browsing')?></b></td></tr>
    <tr><td width="200"><?=_('Language')?></td><td>
	<form action=""><select name="lang" onchange="if(selectedIndex!=0) window.location.href='?lang='+options[selectedIndex].value+'&amp;id=<?=$id . $debug?>';">
	  <option value=""><?=_('Language')?></option>
<?
$q = @mysql_query("SELECT IDLanguage, Nome, Codice FROM ${dbprefix}_Languages ORDER BY IDLanguage") or die(_('I can\'t query the DB: '));
while($row = @mysql_fetch_row($q))
    echo "	  <option value=\"$row[0]\"" . ($row[0] == $lang ? ' selected' : '') . ">$row[1] ($row[2])</option>\n";
@mysql_free_result($q);
?>
	</select></form>
    </td></tr>
    <tr><td><?=_('Strip')?></td><td>
	<form action=""><select name="strip_id" onchange="if(selectedIndex!=0) window.location.href='?lang=<?=$lang?>&amp;id='+options[selectedIndex].value+'<?=$debug?>';">
	  <option value=""><?=_('MegaTokyo Archives')?></option>
<?
$q = @mysql_query("SELECT IDStrip, Testo, UNIX_TIMESTAMP(Pubblicazione) AS Pubblicazione FROM ${dbprefix}_Titles WHERE IDLanguage = '$lang' ORDER BY IDStrip DESC") or die(_('I can\'t query the DB: '));
while($row = @mysql_fetch_row($q))
    echo "	  <option value=\"$row[0]\"" . ($row[0] == $id ? ' selected' : '') . '>' . mb_convert_encoding(strftime('%Y-%m-%d %a', $row[2]), "UTF-8", "ASCII") . " [$row[0]] $row[1]</option>\n";
@mysql_free_result($q);
?>
	</select></form>
    </td></tr>
    <tr><td><?=_('Baloon')?></td><td>
	<form action=""><select name="idfumetto" onchange="if(selectedIndex!=0) window.location.href='?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum='+options[selectedIndex].value+'<?=$debug?>';">
	  <option value=""><?=_('Baloon')?></option>
<?
$q = @mysql_query("SELECT ${dbprefix}_Baloons.IDBaloon, ${dbprefix}_Characters.Name FROM (${dbprefix}_Baloons LEFT JOIN ${dbprefix}_Characters ON ${dbprefix}_Baloons.IDCharacter = ${dbprefix}_Characters.IDCharacter) WHERE ${dbprefix}_Baloons.IDStrip = $id ORDER BY IDBaloon") or die(_('I can\'t query the DB: '));
while($row = @mysql_fetch_row($q))
    echo "	  <option value=\"$row[0]\"" . ($row[0] == $fum ? ' selected' : '') . ">$row[0] $row[1]</option>\n";
@mysql_free_result($q);
?>
	</select></form>
    </td></tr>
    <tr><td><?=_('Debug')?></td><td>
	<form action="">
	    <input type="button" value="ON" onclick="window.location.href='?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum=<?=$fum?>&debug=1';"/>
	    <input type="button" value="OFF" onclick="window.location.href='?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum=<?=$fum?>';"/>
	</form>
    </td></tr>
<?
$q = @mysql_query("SELECT Testo, Pubblicazione, Discussione FROM ${dbprefix}_Titles WHERE IDStrip = $id AND IDLanguage = '$lang'") or die(_('I can\'t query the DB: '));
if($row = @mysql_fetch_row($q)) {
    $titolo = $row[0];
    $pubblicazione = $row[1];
    $discussione = $row[2];
} else {
    $titolo = '';
    $pubblicazione = date('Y-m-d');
    $discussione = '';
}
@mysql_free_result($q);
?>
    <form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum=<?=$fum?><?=$debug?>" method="post">
    <input name="tipo" type="hidden" value="titolo"/>
    <input name="idtavola" type="hidden" value="<?=$id?>"/>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2"><b><?=_('This Title')?></b> <?=_('(creation/editing of language-specific strips)')?></td></tr>
    <tr><td><?=_('ID of the Strip')?></td><td><input name="idtavola" type="text" size="10" value="<?=$id?>"/></td></tr>
    <tr><td><?=_('Text')?></td><td><input name="testo" type="text" size="40" value="<?=$titolo?>"/></td></tr>
    <tr><td><?=_('Date of publication')?></td><td><input name="pubblicazione" type="text" size="10" maxlength="10" value="<?=$pubblicazione?>"/> <?=_('date is in the past')?><input name="pubblicazione_ok" type="checkbox" value="1"/></td></tr>
    <tr><td><?=_('Forum thread')?></td><td><input name="discussione" type="text" size="40" value="<?=$discussione?>"/></td></tr>
    <tr><td/><td><input type="submit" value="Insert/Update"/><input type="reset" value="Reset"/></td></tr>
    </form>
    <form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum=<?=$fum?><?=$debug?>" method="post" name="myf">
    <input name="tipo" type="hidden" value="fumetto"/>
    <input name="idfumetto" type="hidden" value="<?=$fum?>"/>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2"><b><?=_('This Baloon')?></b> <?=_('(creation/editing of shapes to blank)')?></td></tr>
    <tr><td><?=_('Shape')?></td><td style="white-space: nowrap;"><input name="coords" type="text" size="40" value="<?=$fum_for?>"><input type="button" value="poly" onclick="document.myf.coords.value = 'p'; return false;"/></td></tr>
    <tr><td><?=_('Character')?></td><td><select name="idpersonaggio">
	<option value="0">------</option>
<?
$q = @mysql_query("SELECT IDCharacter, Name FROM ${dbprefix}_Characters ORDER BY IDCharacter") or die(_('I can\'t query the DB: ') . mysql_error());
while($row = @mysql_fetch_array($q))
    echo '	<option value="' . $row["IDCharacter"] . '"' . ($fum_per == $row["IDCharacter"] ? '" selected>' : '>') . $row["Name"] . "</option>\n";
@mysql_free_result($q);
?>
    </select></td></tr>
    <input name="idtesto" type="hidden" value="<?
if($fum) {
    $q = @mysql_query("SELECT IDText, CenterX, CenterY, Testo FROM ${dbprefix}_Texts WHERE IDLanguage = '$lang' AND IDBaloon = $fum") or die(_('I can\'t query the DB: ') . mysql_error());
    $row = @mysql_fetch_array($q);
    $fum_cx = (string)$row['CenterX'];
    $fum_cy = (string)$row['CenterY'];
    @mysql_free_result($q);
}
if(!$fum || !$row) {
    echo "0";
    $testo = '';
} else {
    echo $row["IDText"];
    $testo = $row["Testo"];
}
?>"/>
    <tr><td><?=_('Center')?></td><td style="white-space: nowrap;"><input name="centrox" type="text" size="6" value="<?=$fum_cx?>">x<input name="centroy" type="text" size="6" value="<?=$fum_cy?>"/></td></tr>
    <tr valign="top"><td><?=_('Text')?></td><td><textarea name="testo" cols="40" rows="6"><?=$testo?></textarea></td></tr>
    <tr><td/><td><input type="button" value="Trim" onclick="trim_lines();"/><?
      if($fum > 0)
	  echo '<input type="submit" name="update" value="Update"><input type="submit" name="insert" value="Insert">';
      else
	  echo '<input type="submit" name="insert" value="Insert">';
    ?><input type="submit" name="delete" value="Delete"><input type="reset" value="Reset"/></td></tr>
    </form>
    </form>
</table>
<br clear="all">
<table width="700">
    <tr><td colspan="2"><b><?=_('This Console')?></b> <?=_('(insert/update rant texts)')?></td></tr>
    <tr valign="top">
<?
foreach(array('sinistra', 'destra') as $lato) {
    $q = @mysql_query("SELECT IDConsole, IDStrip, Username, Titolo FROM ${dbprefix}_Console WHERE IDLanguage = '$lang' AND IDStrip < $id AND Posizione = '$lato' ORDER BY IDStrip DESC LIMIT 1") or die(_('I can\'t query the DB: ') . mysql_error());
    $row = @mysql_fetch_array($q);
    @mysql_free_result($q);
?>
	<td width="50%"><form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;fum=<?=$fum?><?=$debug?>" method="post">
	    <?=_('Previous rant')?><? if($row) { ?> (<?=$row['IDStrip']?>):<br/>
	    "<?=$row['Titolo']?>"<br/>
	    <?=$row['Username']?><? } else echo ': ' . _('none'); ?><br/>
	    <br/>
<?
    $q = @mysql_query("SELECT IDConsole, Username, Immagine, ImmagineLink, ImmagineAlt, Titolo, Testo FROM ${dbprefix}_Console WHERE IDLanguage = '$lang' AND IDStrip = $id AND Posizione = '$lato'") or die(_('I can\'t query the DB: ') . mysql_error());
    $row = @mysql_fetch_array($q);
?>
	    <input name="tipo" type="hidden" value="console"/>
	    <input name="idconsole" type="hidden" value="<?=$row['IDConsole']?>"/>
	    <input name="posizione" type="hidden" value="<?=$lato?>"/>
	    <?=_('Username')?><br/>
	    <select name="username">
		<option value="">------</option>
<?
    $q2 = @mysql_query("SELECT Username FROM ${dbprefix}_Staff WHERE IDLanguage = '$lang' ORDER BY Username") or die(_('I can\'t query the DB: '));
    while($row2 = @mysql_fetch_row($q2))
	echo "		<option value=\"$row2[0]\"" . ($row2[0] == $row['Username'] ? ' selected' : '') . "> $row2[0]</option>";
    @mysql_free_result($q2);
?>
	    </select><br/>
	    <?=_('Image')?><br/>
	    <select name="immagine">
		<option value="">------</option>
<?
    foreach(glob("rantimg/*") as $image)
	echo "		<option value=\"$image\"" . ($image == $row['Immagine'] ? ' selected' : '') . '> ' . substr($image, 8) . '</option>';
?>
	    </select><br/>
	    <?=_('Image link')?><br/>
	    <input type=text name="imm_link" size="40" value="<?=$row['ImmagineLink']?>"/><br/>
	    <?=_('Image alternate text')?><br/>
	    <input type=text name="imm_alt" size="40" value="<?=$row['ImmagineAlt']?>"/><br/>
	    <?=_('Title')?><br/>
	    <input type=text name="titolo" size="40" value="<?=$row['Titolo']?>"/><br/>
	    <?=_('Text')?><br/>
	    <textarea name="testo" cols="40" rows="15"><?=$row['Testo']?></textarea>
	    <br/>
	    <input type="submit" value="Update"><input type="reset" value="Reset">
<?
    @mysql_free_result($q);
?>
	</form></td>
<?
}
?>
    </tr>
</table>

<script type="text/javascript">
function coordX(e) {
    if(e.offsetX) // Opera and IE
	return e.offsetX;
    if(e.pageX) // Mozilla
	return e.pageX - document.myimage.x;
    return NaN;
}

function coordY(e) {
    if(e.offsetY) // Opera and IE
	return e.offsetY;
    if(e.pageY) // Mozilla
	return e.pageY - document.myimage.y;
    return NaN;
}

function addCoords(event) {
    if(!event)
	event = window.event;
    document.myf.coords.value += "," + coordX(event) + "," + coordY(event);
    return false;
}

function trackCoords(event) {
    if(!event)
	event = window.event;
    self.status = "(" + coordX(event) + "," + coordY(event) + ")";
    document.myf.centrox.value = coordX(event);
    document.myf.centroy.value = coordY(event);
    return false;
}

function clearCoords(event) {
    document.myf.coords.value = "p";
    return false;
}

re_spezza = /\n */g;
function trim_lines(event) {
    document.myf.testo.value = document.myf.testo.value.replace(re_spezza, "\n");
}

document.myimage.onclick = addCoords;
document.myimage.onmouseup = trackCoords;
document.myimage.ondblclick = clearCoords;
</script>

</body>
</html>

